unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, FastHTMLParser,FileCtrl;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Information: TMemo;
    Page: TMemo;
    Source: TMemo;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Parse1(ItCode:string);
    procedure OnTag(Tag: string);
    procedure Button1Click(Sender: TObject);
  private
      Tg : integer;
      Buffer : TStrings;
  public
  end;

var
  Form1: TForm1;
  Modified:Boolean;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
    //create general stringlist
    Buffer:= TStringList.Create;
    
    //вmemoʾ
    Source.Lines.Text:=Utf8ToAnsi(Source.Lines.Text);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
{clean up general stringlist}
  Buffer.Free; Buffer:= nil;
end;

procedure TForm1.Parse1(ItCode:string);
var
  Parser : TjsFastHTMLParser; //our fasthtmlparser class
  Strings : tStrings;
begin
  buffer.clear;            //clear stringlist since it's in the memory all the time
  begin
    Strings:= tStringList.Create;
    Tg:= 0;
    Parser:= tjsFastHTMLParser.Create(Pchar(Source.Text));
    Parser.OnFoundTag := OnTag;
    Parser.exec;           //ExecUpCaseôеĶᱻתΪд
    Parser.Free;

    Strings.Free;
  end;
end;

//жVaule Ƿдĸ
function HasUpperCase(Vaule:String):Boolean;
var
  i:integer;
begin
  result:=False; //÷ֵΪû

  for i:=1 to length(Vaule) do //׼ѭ
    begin
      if Vaule[i] in ['A'..'Z'] then //Vauleгһдĸͱддĸ
        begin
          result:=True; //ֵ 
          exit; //˳
        end;
    end;
end;

procedure TForm1.OnTag(Tag: string);
//show all tags
begin
  Inc(Tg);
  //صĳӺʾͼƬҪддתСд
  if ((pos('<a href=',Lowercase(Tag))<>0) or
        (pos('<img src=',Lowercase(Tag))<>0)) then
       begin
         if HasUpperCase(Tag) then
           begin
             Modified:=True;
             Information.Lines.Add('Find: '+Tag);
             Source.Text := StringReplace(Source.Text,Tag,LowerCase(Tag), [rfReplaceAll]);
           end;
       end;
end;

procedure TForm1.Button1Click(Sender: TObject);

//öһĿ¼µļ
procedure   FileSearch(PathName:string);
var
    F   :   TSearchRec;
    Found   :   Boolean;
begin
    if copy(PathName,length(PathName),1)<>'\' then PathName:=PathName+'\';
    ChDir(PathName);
    Found   :=   (FindFirst( '*.*',   faAnyFile,   F)   =   0);
    while   Found   do
    begin
        if   (F.Name   =   '.')   or   (F.Name   =   '..')   then
        begin
            Found   :=   (FindNext(F)   =   0);
            Continue;
        end;

        if   (F.Attr   and   faDirectory)> 0   then
        begin
            Application.ProcessMessages;
            FileSearch(PathName+F.Name);
        end;

        if (ExtractFileExt(F.Name)='.htm') or (ExtractFileExt(F.Name)='.html') then
          begin
            //Ĵ룬F.NameļGetCurrentDirԵõǰĿ¼
            Page.Lines.Add(PathName+F.Name);
          end;
        Found   :=   (FindNext(F)   =   0);

    end;
    FindClose(F);
end;

var
   szPath:string;
begin
  SelectDirectory('ѡվĿ¼','',szPath);
  if szPath<>'' then
    begin
      if copy(szPath,length(szPath),1)<>'\' then szPath:=szPath+'\';
      FileSearch(szPath);
    end;

  repeat
    //ҳǷҪ޸
    Modified:=False;

    //δбĵһ
    Source.Lines.LoadFromFile(Page.Lines[0]);

    //ҳ
    Parse1(Page.Lines[0]);

    // Tg<>0 ҵдˣҪ޸
    if Modified=True then
      begin
        //ԭļ.bak׺
        if RenameFile(Page.Lines[0],Page.Lines[0]+'.bak')=false then
          begin
            ShowMessage('ļ'+Page.Lines[0]+'ʱ󣬳ֹͣ');
            exit;
          end;
        //Ѿ޸Դ
        Source.Lines.SaveToFile(Page.Lines[0]);
      end;

    //ɾδбĵһ
    Page.Lines.Delete(0);
  until Page.Lines.Count=0;
end;

end.



